﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using Microsoft.SharePoint.Client;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        ClientContext ctx;
        ListItemCollection contactsListItems;

        public MainPage()
        {
            // Required to initialize variables
            InitializeComponent();

            //Get SharePoint List after page loads
            this.Loaded += MainPage_Loaded;
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            //LoadClientOM
            LoadClientOM loadClientOM = new LoadClientOM(delegate() { LoadList(); });
            loadClientOM.Run();


            //LoadList();
        }

        //LoadList
        void LoadList(){
            //Get Client Context
            ctx = ClientContext.Current;

            //TODO: Code to detect out of browser and store in isolated storage.

            if (ctx != null) //null if we are not in SharePoint
            {
                //Get Contacts from SharePoint
                List contactsList = ctx.Web.Lists.GetByTitle("Contacts");
                contactsListItems =
                    contactsList.GetItems(CamlQuery.CreateAllItemsQuery());

                ctx.Load(contactsListItems);
                ctx.ExecuteQueryAsync(ContactsLoaded, ContactsLoadedFail);
            }
        }

        //ContactsLoadedFail
        void ContactsLoadedFail(object sender, ClientRequestFailedEventArgs args)
        {
            //TODO: Handle any Error;
        }

        //ContactsLoaded
        void ContactsLoaded(object sender, ClientRequestSucceededEventArgs args)
        {
            //TODO: remove - use for debugging
            int cnt = contactsListItems.Count;

            //foreach (string key in contactsListItems[0].FieldValues.Keys)
            //{
            //    System.Diagnostics.Debug.WriteLine(key + " = " + contactsListItems[0].FieldValues[key]);
            //}

            //call back on the UI thread
            this.Dispatcher.BeginInvoke(() =>
            {
                ContactsListBox.ItemsSource = contactsListItems;
            });
            
            //or this
            //System.Windows.Deployment.Current.Dispatcher.BeginInvoke(() =>
            //{
                
            //});
        }

    }
}